<!doctype html>
<html>
<head>
    <title>New release: Tor 0.3.5.4-alpha | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="New release: Tor 0.3.5.4-alpha | Tor Project">
    <meta property="og:description" content="There&#39;s a new alpha release available for download. If you build Tor from source, you can download the source code for 0.3.5.4-alpha from the usual place on the website. Packages should be available over the coming weeks, with a new alpha Tor Browser release by mid-December. Remember, this is an alpha release: you should only run this if you&#39;d like to find and report more bugs than usual. Tor 0.3.5.4-alpha includes numerous bugfixes on earlier versions and improves our continuous integration support. It continues our attempts to stabilize this alpha branch and build it into a foundation for an acceptable long-term-support release. Changes in version 0.3.5.4-alpha - 2018-11-08 Major bugfixes (compilation, rust): Rust tests can now build and run successfully with the --enable-fragile-hardening option enabled. Doing this currently requires the rust beta channel; it will be possible with stable rust once Rust version 1.31 is released. Patch from Alex Crichton. Fixes bugs 27272, 27273, and 27274. Bugfix on 0.3.1.1-alpha. Major bugfixes (embedding, main loop): When DisableNetwork becomes set, actually disable periodic events that are already enabled. (Previously, we would refrain from enabling new ones, but we would leave the old ones turned on.) Fixes bug 28348; bugfix on 0.3.4.1-alpha.">
    <meta property="og:image" content="https://blog.torproject.org/new-release-tor-0354-alpha/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/new-release-tor-0354-alpha/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        New release: Tor 0.3.5.4-alpha
      </h1>
    <p class="meta">by nickm | November 8, 2018</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>There's a new alpha release available for download. If you build Tor from source, you can download the source code for 0.3.5.4-alpha from the usual place on the website. Packages should be available over the coming weeks, with a new alpha Tor Browser release by mid-December.</p>
<p>Remember, this is an alpha release: you should only run this if you'd like to find and report more bugs than usual.</p>
<p>Tor 0.3.5.4-alpha includes numerous bugfixes on earlier versions and improves our continuous integration support. It continues our attempts to stabilize this alpha branch and build it into a foundation for an acceptable long-term-support release.</p>
<h2>Changes in version 0.3.5.4-alpha - 2018-11-08</h2>
<ul>
<li>Major bugfixes (compilation, rust):
<ul>
<li>Rust tests can now build and run successfully with the --enable-fragile-hardening option enabled. Doing this currently requires the rust beta channel; it will be possible with stable rust once Rust version 1.31 is released. Patch from Alex Crichton. Fixes bugs 27272, 27273, and 27274. Bugfix on 0.3.1.1-alpha.</li>
</ul>
</li>
<li>Major bugfixes (embedding, main loop):
<ul>
<li>When DisableNetwork becomes set, actually disable periodic events that are already enabled. (Previously, we would refrain from enabling new ones, but we would leave the old ones turned on.) Fixes bug <a href="https://bugs.torproject.org/28348">28348</a>; bugfix on 0.3.4.1-alpha.</li>
</ul>
</li>
</ul>
<p> </p>
<!--break--><ul>
<li>Minor features (continuous integration):
<ul>
<li>Add a Travis CI build for --enable-nss on Linux gcc. Closes ticket <a href="https://bugs.torproject.org/27751">27751</a>.</li>
<li>Add new CI job to Travis configuration to run stem-based integration tests. Closes ticket <a href="https://bugs.torproject.org/27913">27913</a>.</li>
</ul>
</li>
<li>Minor features (Windows, continuous integration):
<ul>
<li>Build tor on Windows Server 2012 R2 and Windows Server 2016 using Appveyor's CI. Closes ticket <a href="https://bugs.torproject.org/28318">28318</a>.</li>
</ul>
</li>
<li>Minor bugfixes (C correctness, also in 0.3.4.9):
<ul>
<li>Avoid undefined behavior in an end-of-string check when parsing the BEGIN line in a directory object. Fixes bug <a href="https://bugs.torproject.org/28202">28202</a>; bugfix on 0.2.0.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (compilation):
<ul>
<li>Fix a pair of missing headers on OpenBSD. Fixes bug <a href="https://bugs.torproject.org/28303">28303</a>; bugfix on 0.3.5.1-alpha. Patch from Kris Katterjohn.</li>
</ul>
</li>
<li>Minor bugfixes (compilation, OpenSolaris):
<ul>
<li>Fix compilation on OpenSolaris and its descendants by adding a missing include to compat_pthreads.c. Fixes bug <a href="https://bugs.torproject.org/27963">27963</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (configuration):
<ul>
<li>Refuse to start with relative file paths and RunAsDaemon set (regression from the fix for bug <a href="https://bugs.torproject.org/22731">22731</a>). Fixes bug <a href="https://bugs.torproject.org/28298">28298</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (directory authority, also in 0.3.4.9):
<ul>
<li>Log additional info when we get a relay that shares an ed25519 ID with a different relay, instead of a BUG() warning with a backtrace. Fixes bug <a href="https://bugs.torproject.org/27800">27800</a>; bugfix on 0.3.2.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (onion service v3):
<ul>
<li>Build the service descriptor's signing key certificate before uploading, so we always have a fresh one: leaving no chances for it to expire service side. Fixes bug <a href="https://bugs.torproject.org/27838">27838</a>; bugfix on 0.3.2.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (onion service v3, client authorization):
<ul>
<li>Fix an assert() when adding a client authorization for the first time and then sending a HUP signal to the service. Before that, Tor would stop abruptly. Fixes bug <a href="https://bugs.torproject.org/27995">27995</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (onion services):
<ul>
<li>Unless we have explicitly set HiddenServiceVersion, detect the onion service version and then look for invalid options. Previously, we did the reverse, but that broke existing configs which were pointed to a v2 service and had options like HiddenServiceAuthorizeClient set. Fixes bug <a href="https://bugs.torproject.org/28127">28127</a>; bugfix on 0.3.5.1-alpha. Patch by Neel Chauhan.</li>
</ul>
</li>
<li>Minor bugfixes (portability):
<ul>
<li>Make the OPE code (which is used for v3 onion services) run correctly on big-endian platforms. Fixes bug <a href="https://bugs.torproject.org/28115">28115</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (protover, rust):
<ul>
<li>Reject extra commas in version strings. Fixes bug <a href="https://bugs.torproject.org/27197">27197</a>; bugfix on 0.3.3.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (relay shutdown, systemd):
<ul>
<li>Notify systemd of ShutdownWaitLength so it can be set to longer than systemd's TimeoutStopSec. In Tor's systemd service file, set TimeoutSec to 60 seconds to allow Tor some time to shut down. Fixes bug <a href="https://bugs.torproject.org/28113">28113</a>; bugfix on 0.2.6.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (rust, also in 0.3.4.9):
<ul>
<li>Fix a potential null dereference in protover_all_supported(). Add a test for it. Fixes bug <a href="https://bugs.torproject.org/27804">27804</a>; bugfix on 0.3.3.1-alpha.</li>
<li>Return a string that can be safely freed by C code, not one created by the rust allocator, in protover_all_supported(). Fixes bug <a href="https://bugs.torproject.org/27740">27740</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (rust, directory authority, also in 0.3.4.9):
<ul>
<li>Fix an API mismatch in the rust implementation of protover_compute_vote(). This bug could have caused crashes on any directory authorities running Tor with Rust (which we do not yet recommend). Fixes bug <a href="https://bugs.torproject.org/27741">27741</a>; bugfix on 0.3.3.6.</li>
</ul>
</li>
<li>Minor bugfixes (testing):
<ul>
<li>Avoid hangs and race conditions in test_rebind.py. Fixes bug <a href="https://bugs.torproject.org/27968">27968</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (testing, also in 0.3.4.9):
<ul>
<li>Treat backtrace test failures as expected on BSD-derived systems (NetBSD, OpenBSD, and macOS/Darwin) until we solve bug <a href="https://bugs.torproject.org/17808">17808</a>. (FreeBSD failures have been treated as expected since 18204 in 0.2.8.) Fixes bug <a href="https://bugs.torproject.org/27948">27948</a>; bugfix on 0.2.5.2-alpha.</li>
</ul>
</li>
<li>Documentation (onion service manpage):
<ul>
<li>Improve HSv3 client authorization by making some options more explicit and detailed. Closes ticket <a href="https://bugs.torproject.org/28026">28026</a>. Patch by Mike Tigas.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-278448"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278448" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 11, 2018</p>
    </div>
    <a href="#comment-278448">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278448" class="permalink" rel="bookmark">Where could I read about Tor…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Where could I read about Tor Project answer to a paper <a href="https://arxiv.org/abs/1808.07285" rel="nofollow">DeepCorr: Strong Flow Correlation Attacks on Tor Using Deep Learning</a>? Was it discussed at mailing lists of tor blog some time ago?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-278481"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278481" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  nickm
  </article>
    <div class="comment-header">
      <p class="comment__submitted">nickm said:</p>
      <p class="date-time">November 15, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-278448" class="permalink" rel="bookmark">Where could I read about Tor…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-278481">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278481" class="permalink" rel="bookmark">Looks like there was a…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Looks like there was a thread starting at <a href="https://www.mail-archive.com/tor-dev@lists.torproject.org/msg10854.html" rel="nofollow">https://www.mail-archive.com/tor-dev@lists.torproject.org/msg10854.html</a> , but I don't know if it will have what you want.  Generally the mailing lists are a better place for this kind of question than the blog.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-278491"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278491" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 16, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to nickm</p>
    <a href="#comment-278491">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278491" class="permalink" rel="bookmark">Thank you!</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thank you!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-278492"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278492" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 16, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to nickm</p>
    <a href="#comment-278492">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278492" class="permalink" rel="bookmark">As I see, they discriminate…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>As I see, they discriminate their own noise traffic from their own target traffic, because both of these types of traffic have to pass through their proxy (after leaving exit node). They used this setup because of privacy issues. They cannot force all exit node traffic pass through their discriminating proxy.</p>
<p>This feature made it easier to discriminate target traffic. It made their distinguisher produce lower false positive and lower false negative rates. It is still good research and very dangerous attack, but I doubt that in real world scenario their probabilities will be as high as they claim.</p>
<p>Do you have another opinion? Use of different AS in path selection, as they propose it, may be a good point.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-278494"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278494" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 16, 2018</p>
    </div>
    <a href="#comment-278494">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278494" class="permalink" rel="bookmark">Is their any simple way to…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Is their any simple way to install alpha versions of tor (as a system service) in stable Debian? I use Tor's repository, but that gives me only last stable Tor version (0.3.4.9 at this moment). Do I have to go through all the troubles with Debian's backports to get 0.3.5.4-alpha?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-278633"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278633" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Amroz  (not verified)</span> said:</p>
      <p class="date-time">November 28, 2018</p>
    </div>
    <a href="#comment-278633">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278633" class="permalink" rel="bookmark">Can I use tor browser…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Can I use tor browser repository  for strech in other debian-based distros , e.g. kali linux</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
